/*---------------------------------INCLUDES--------------------------------*/
#include "asm.h"


/*---------------------------------FUNCTIONS-------------------------------*/

void setIntLevel(u8 level) {
	asm("
		stsr	sr5,r5 
		movhi	0xFFF1,r0,r6
		movea	0xFFFF,r6,r6
		and		r5,r6
		mov		%0,r5
		andi	0x000F,r5,r5
		shl		0x10,r5
		or		r6,r5
		ldsr	r5,sr5
		"	
	: // Output 
	: "r" (level) // Input 
	: "r5", "r6" // Clobber 
	);
	
}


inline int geIntLevel() {
	int level;

	asm("
		stsr	sr5,r5
		shr		0x10,r5
		andi	0x000F,r5,r5
		mov		r5,%0
	"
	: "=r" (level) // Output 
	: // Input 
	: "r5" // Clobber 
	);
	
	return level;
}

inline int getPSW() {
	int psw;
	asm("
		stsr	psw,%0 
		"	
	: "=r" (psw) // Output 
	);
	return psw;
}

