/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef GLOBALS_H_
#define GLOBALS_H_
/*---------------------------------INCLUDES--------------------------------*/
#include "Error.h"
#include "MemoryPool.h"
#include "Stage.h"
//#include "GameEngine.h"
#include "BgmapManager.h"
#include "FrameRate.h"
#include "ParamTableManager.h"
#include "CharSetManager.h"
#include "Clock.h"
#include "SoundManager.h"

/*-----------------------------------GLOBALS-------------------------------*/
/* global pointers to various gameengine's attributes 
 * to access them from each class of the engine
 */

extern const u16*			_asciiChar;
extern Optical *			_optical;
extern Clock				_clock;
extern Clock				_inGameClock;
extern MovementState *		_screenMovementState;
extern VBVec3D *			_screenPosition;

extern float _timeElapsed;
#endif
